/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CreateGlobalRolloutRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateGlobalRolloutRequest{}

// CreateGlobalRolloutRequest struct for CreateGlobalRolloutRequest
type CreateGlobalRolloutRequest struct {
	Targets []RolloutTarget `json:"targets,omitempty"`
	// This should be true always. False only for test reasons
	Async *bool `json:"async,omitempty"`
	ForceGlobalMedia *bool `json:"force_global_media,omitempty"`
}

// NewCreateGlobalRolloutRequest instantiates a new CreateGlobalRolloutRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateGlobalRolloutRequest() *CreateGlobalRolloutRequest {
	this := CreateGlobalRolloutRequest{}
	return &this
}

// NewCreateGlobalRolloutRequestWithDefaults instantiates a new CreateGlobalRolloutRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateGlobalRolloutRequestWithDefaults() *CreateGlobalRolloutRequest {
	this := CreateGlobalRolloutRequest{}
	return &this
}

// GetTargets returns the Targets field value if set, zero value otherwise.
func (o *CreateGlobalRolloutRequest) GetTargets() []RolloutTarget {
	if o == nil || IsNil(o.Targets) {
		var ret []RolloutTarget
		return ret
	}
	return o.Targets
}

// GetTargetsOk returns a tuple with the Targets field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateGlobalRolloutRequest) GetTargetsOk() ([]RolloutTarget, bool) {
	if o == nil || IsNil(o.Targets) {
		return nil, false
	}
	return o.Targets, true
}

// HasTargets returns a boolean if a field has been set.
func (o *CreateGlobalRolloutRequest) HasTargets() bool {
	if o != nil && !IsNil(o.Targets) {
		return true
	}

	return false
}

// SetTargets gets a reference to the given []RolloutTarget and assigns it to the Targets field.
func (o *CreateGlobalRolloutRequest) SetTargets(v []RolloutTarget) {
	o.Targets = v
}

// GetAsync returns the Async field value if set, zero value otherwise.
func (o *CreateGlobalRolloutRequest) GetAsync() bool {
	if o == nil || IsNil(o.Async) {
		var ret bool
		return ret
	}
	return *o.Async
}

// GetAsyncOk returns a tuple with the Async field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateGlobalRolloutRequest) GetAsyncOk() (*bool, bool) {
	if o == nil || IsNil(o.Async) {
		return nil, false
	}
	return o.Async, true
}

// HasAsync returns a boolean if a field has been set.
func (o *CreateGlobalRolloutRequest) HasAsync() bool {
	if o != nil && !IsNil(o.Async) {
		return true
	}

	return false
}

// SetAsync gets a reference to the given bool and assigns it to the Async field.
func (o *CreateGlobalRolloutRequest) SetAsync(v bool) {
	o.Async = &v
}

// GetForceGlobalMedia returns the ForceGlobalMedia field value if set, zero value otherwise.
func (o *CreateGlobalRolloutRequest) GetForceGlobalMedia() bool {
	if o == nil || IsNil(o.ForceGlobalMedia) {
		var ret bool
		return ret
	}
	return *o.ForceGlobalMedia
}

// GetForceGlobalMediaOk returns a tuple with the ForceGlobalMedia field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateGlobalRolloutRequest) GetForceGlobalMediaOk() (*bool, bool) {
	if o == nil || IsNil(o.ForceGlobalMedia) {
		return nil, false
	}
	return o.ForceGlobalMedia, true
}

// HasForceGlobalMedia returns a boolean if a field has been set.
func (o *CreateGlobalRolloutRequest) HasForceGlobalMedia() bool {
	if o != nil && !IsNil(o.ForceGlobalMedia) {
		return true
	}

	return false
}

// SetForceGlobalMedia gets a reference to the given bool and assigns it to the ForceGlobalMedia field.
func (o *CreateGlobalRolloutRequest) SetForceGlobalMedia(v bool) {
	o.ForceGlobalMedia = &v
}

func (o CreateGlobalRolloutRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateGlobalRolloutRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Targets) {
		toSerialize["targets"] = o.Targets
	}
	if !IsNil(o.Async) {
		toSerialize["async"] = o.Async
	}
	if !IsNil(o.ForceGlobalMedia) {
		toSerialize["force_global_media"] = o.ForceGlobalMedia
	}
	return toSerialize, nil
}

type NullableCreateGlobalRolloutRequest struct {
	value *CreateGlobalRolloutRequest
	isSet bool
}

func (v NullableCreateGlobalRolloutRequest) Get() *CreateGlobalRolloutRequest {
	return v.value
}

func (v *NullableCreateGlobalRolloutRequest) Set(val *CreateGlobalRolloutRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateGlobalRolloutRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateGlobalRolloutRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateGlobalRolloutRequest(val *CreateGlobalRolloutRequest) *NullableCreateGlobalRolloutRequest {
	return &NullableCreateGlobalRolloutRequest{value: val, isSet: true}
}

func (v NullableCreateGlobalRolloutRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateGlobalRolloutRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


